#include <bits/stdc++.h>
using namespace std;

struct DSU {
    int n;
    vector<int> par, sz, mx;
    vector<bool> hasLoop;

    DSU(int m) {
        n = m;
        par.assign(n + 1, -1);
        sz.assign(n + 1, 1);
        mx.assign(n + 1, 0);
        hasLoop.assign(n + 1, false);

        for (int i = 0; i <= n; i++) {
            par[i] = i;
            mx[i] = i;
        }
    }

    int findSet(int node) {
        if (par[node] == node) {
            return node;
        }
        return par[node] = findSet(par[node]);
    }

    void unionSets(int a, int b) {
        a = findSet(a);
        b = findSet(b);
        if (a == b) return;
        if (sz[a] > sz[b]) swap(a, b);
        par[a] = b;
        sz[b] += sz[a];
        mx[b] = max(mx[b], mx[a]);
        if (hasLoop[a]) {
            hasLoop[b] = true;
        }
    }
    
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    int a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    int b[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }


    int q;
    cin >> q;

    while (q--) {
        int l, r;
        cin >> l >> r;

        DSU dsu = DSU(n + 1);

        for (int i = l; i <= r; i++) {
            if (dsu.findSet(a[i]) == dsu.findSet(b[i])) {
                dsu.hasLoop[dsu.findSet(a[i])] = true;
            }
            else {
                dsu.unionSets(a[i], b[i]);
            }
        }

        int ans = -1;

        for (int i = 0; i <= n; i++) {
            if (!dsu.hasLoop[dsu.findSet(i)] && dsu.mx[dsu.findSet(i)] == i) {
                ans = i;
                break;
            }
        }

        printf("%i\n", ans);
    }
}
