#include <bits/stdc++.h>
using namespace std;

struct DSU {
    int n;
    vector<int> par, sz, mx;
    vector<bool> hasLoop;

    DSU(int m) {
        n = m;
        par.assign(n + 1, -1);
        sz.assign(n + 1, 1);
        mx.assign(n + 1, 0);
        hasLoop.assign(n + 1, false);

        for (int i = 0; i <= n; i++) {
            par[i] = i;
            mx[i] = i;
        }
    }

    int findSet(int node) {
        if (par[node] == node) {
            return node;
        }
        return par[node] = findSet(par[node]);
    }

    void unionSets(int a, int b) {
        a = findSet(a);
        b = findSet(b);
        if (a == b) return;
        if (sz[a] > sz[b]) swap(a, b);
        par[a] = b;
        sz[b] += sz[a];
        mx[b] = max(mx[b], mx[a]);
        if (hasLoop[a]) {
            hasLoop[b] = true;
        }
    }
    
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    int a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    int b[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }

    int pref1[n + 1] = {};
    int pref0[n + 1] = {};
    int pref01[n + 1] = {};

    for (int i = 1; i <= n; i++) {
        pref1[i] = pref1[i - 1], pref0[i] = pref0[i - 1], pref01[i] = pref01[i - 1];
        if (a[i] == 1 && b[i] == 1) {
            pref1[i]++;
        }
        else if (a[i] == 0 && b[i] == 0) {
            pref0[i]++;
        }
        else {
            pref01[i]++;
        }
    }


    int q;
    cin >> q;

    while (q--) {
        int l, r;
        cin >> l >> r;

        if (r - l == 0) {
            if (a[l] == 1 && b[l] == 1) {
                printf("0\n");
            }
            else {
                printf("1\n");
            }
        }
        else {
            if (pref1[r] - pref1[l - 1] == r - l + 1) {
                printf("0\n");
            }
            else if (pref0[r] - pref0[l - 1] == r - l + 1) {
                printf("1\n");
            }
            else {
                printf("2\n");
            }
        }
    }
}
