#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;

bool check(int n, const vector<ll>& x, const vector<ll>& t, ll zt) {
	vector<pair<int, int>> pr(n);
	for (int i = 0; i < n; i++) {
		if (t[i] == 0) {
			pr[i] = { 0, n - 1 };
			continue;
		}
		pr[i].first = max(0ll, x[i] - 1 - zt / t[i]);
		pr[i].second = min(n - 1ll, x[i] - 1 + zt / t[i]);
	}
	sort(pr.begin(), pr.end());
	int p1 = 0;
	multiset<int> st;
	for (int pos_x = 0; pos_x < n; pos_x++) {
		while (p1 < n && pr[p1].first == pos_x) {
			st.insert(pr[p1].second);
			p1++;
		}
		if (st.empty())
			return false;
		if ((*st.begin()) < pos_x)
			return false;
		st.erase(st.begin());
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<ll> x(n), t(n);
	for (int i = 0; i < n; i++)
		cin >> x[i] >> t[i];
	ll l = -1;
	ll r = 1e18;
	while (l + 1 < r) {
		ll md = (l + r) / 2;
		if (check(n, x, t, md))
			r = md;
		else
			l = md;
	}
	cout << r << "\n";
}
